class String
  def snakecase
    self.gsub(/::/, '/'). # Convert namespace to slash
    gsub(/([A-Z]+)([A-Z][a-z])/,'\1_\2').
    gsub(/([a-z\d])([A-Z])/,'\1_\2').
    tr('-', '_').
    gsub(/\s/, '_').
    gsub(/__+/, '_').
    downcase
  end

  def camelcase
    return self if self !~ /_/ && self =~ /[A-Z]+.*/
    self.split('_').map(&:capitalize).join
  end

  def lower_camelcase
    self[0].chr.downcase + self.camelcase[1..-1]
  end

  def classify
    self.split('/').collect do |c|
      c.camelcase
    end.join('::')
  end

  def tableify
    self.snakecase + 's'
  end
end

class Object
  def in container
    container.include? self
  end
end
